/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.132 Revision 1.221
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.132 2005/07/06 02:09:40 dostrow Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.221 2009/10/20 19:17:59 zmedico Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2005 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
22# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# the patchset version for 31# the patchset version for
30# and not use it as a true package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36# 39#
37# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
38# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
39# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
40# combination of "base" and "extras" 43# combination of "base" and "extras"
41# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
42# A value of "5" would apply genpatches-2.6.12-5 to 45# A value of "5" would apply genpatches-2.6.12-5 to
43# my-sources-2.6.12.ebuild 46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
44 48
45# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 49# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
46# can be supported by the headers ebuild 50# can be supported by the headers ebuild
47 51
48# UNIPATCH_LIST - space delimetered list of patches to be applied to the 52# UNIPATCH_LIST - space delimetered list of patches to be applied to the
54# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 58# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
55# the doc dir 59# the doc dir
56# UNIPATCH_STRICTORDER - if this is set places patches into directories of 60# UNIPATCH_STRICTORDER - if this is set places patches into directories of
57# order, so they are applied in the order passed 61# order, so they are applied in the order passed
58 62
59inherit toolchain-funcs versionator multilib 63inherit eutils toolchain-funcs versionator multilib
60ECLASS="kernel-2"
61INHERITED="$INHERITED $ECLASS"
62EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 64EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst pkg_postinst
63 pkg_preinst pkg_postinst pkg_prerm
64 65
65# Added by Daniel Ostrow <dostrow@gentoo.org> 66# Added by Daniel Ostrow <dostrow@gentoo.org>
66# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 67# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
67# I will remove it when I come up with something more reasonable. 68# I will remove it when I come up with something more reasonable.
68[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 69[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
69 70
70export CTARGET=${CTARGET:-${CHOST}} 71export CTARGET=${CTARGET:-${CHOST}}
71if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 72if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
72 export CTARGET=${CATEGORY/cross-} 73 export CTARGET=${CATEGORY/cross-}
73fi 74fi
74 75
75HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 76HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
76LICENSE="GPL-2" 77LICENSE="GPL-2"
77 78
79# No need to run scanelf/strip on kernel sources/headers (bug #134453).
80RESTRICT="binchecks strip"
81
78# set LINUX_HOSTCFLAGS if not already set 82# set LINUX_HOSTCFLAGS if not already set
79[ -z "$LINUX_HOSTCFLAGS" ] && \ 83[[ -z ${LINUX_HOSTCFLAGS} ]] && \
80 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 84 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
85
86# debugging functions
87#==============================================================
88# this function exists only to help debug kernel-2.eclass
89# if you are adding new functionality in, put a call to it
90# at the start of src_unpack, or during SRC_URI/dep generation.
91debug-print-kernel2-variables() {
92 debug-print "PVR: ${PVR}"
93 debug-print "CKV: ${CKV}"
94 debug-print "OKV: ${OKV}"
95 debug-print "KV: ${KV}"
96 debug-print "KV_FULL: ${KV_FULL}"
97 debug-print "RELEASETYPE: ${RELEASETYPE}"
98 debug-print "RELEASE: ${RELEASE}"
99 debug-print "UNIPATCH_LIST_DEFAULT: ${UNIPATCH_LIST_DEFAULT} "
100 debug-print "UNIPATCH_LIST_GENPATCHES: ${UNIPATCH_LIST_GENPATCHES} "
101 debug-print "UNIPATCH_LIST: ${UNIPATCH_LIST}"
102 debug-print "S: ${S}"
103 debug-print "KERNEL_URI: ${KERNEL_URI}"
104}
81 105
82#Eclass functions only from here onwards ... 106#Eclass functions only from here onwards ...
83#============================================================== 107#==============================================================
84handle_genpatches() { 108handle_genpatches() {
85 local tarball 109 local tarball
86 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1 110 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
87 111
88 for i in ${K_WANT_GENPATCHES} ; do 112 for i in ${K_WANT_GENPATCHES} ; do
89 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 113 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
90 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 114 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
91 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 115 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
134 158
135 RELEASE=${CKV/${OKV}} 159 RELEASE=${CKV/${OKV}}
136 RELEASE=${RELEASE/_beta} 160 RELEASE=${RELEASE/_beta}
137 RELEASE=${RELEASE/_rc/-rc} 161 RELEASE=${RELEASE/_rc/-rc}
138 RELEASE=${RELEASE/_pre/-pre} 162 RELEASE=${RELEASE/_pre/-pre}
139 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-bk} 163 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
140 RELEASETYPE=${RELEASE//[0-9]} 164 RELEASETYPE=${RELEASE//[0-9]}
141 165
142 # Now we know that RELEASE is the -rc/-bk 166 # Now we know that RELEASE is the -rc/-git
143 # and RELEASETYPE is the same but with its numerics stripped 167 # and RELEASETYPE is the same but with its numerics stripped
144 # we can work on better sorting EXTRAVERSION. 168 # we can work on better sorting EXTRAVERSION.
145 # first of all, we add the release 169 # first of all, we add the release
146 EXTRAVERSION="${RELEASE}" 170 EXTRAVERSION="${RELEASE}"
171 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
147 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 172 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
148 173
174 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
175 if [[ -n "${K_NOUSEPR}" ]]; then
176 # Don't add anything based on PR to EXTRAVERSION
177 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
149 if [[ -n ${K_PREPATCHED} ]]; then 178 elif [[ -n ${K_PREPATCHED} ]]; then
179 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
150 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 180 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
151 elif [[ "${ETYPE}" = "sources" ]]; then 181 elif [[ "${ETYPE}" = "sources" ]]; then
182 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
152 # For some sources we want to use the PV in the extra version 183 # For some sources we want to use the PV in the extra version
153 # This is because upstream releases with a completely different 184 # This is because upstream releases with a completely different
154 # versioning scheme. 185 # versioning scheme.
155 case ${PN/-*} in 186 case ${PN/-*} in
156 wolk) K_USEPV=1;; 187 wolk) K_USEPV=1;;
157 vserver) K_USEPV=1;; 188 vserver) K_USEPV=1;;
158 esac 189 esac
159 190
160 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 191 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
161 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 192 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
162 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 193 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
163 fi 194 fi
195 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
164 196
165 # The only messing around which should actually effect this is for KV_EXTRA 197 # The only messing around which should actually effect this is for KV_EXTRA
166 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 198 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
167 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 199 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
168 if [[ -n ${KV_EXTRA} ]]; then 200 if [[ -n ${KV_EXTRA} ]]; then
169 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 201 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
170 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 202 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2
171 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2" 203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2"
172 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2" 204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
173 fi 205 fi
174 206
175 # We need to set this using OKV, but we need to set it before we do any 207 # We need to set this using OKV, but we need to set it before we do any
176 # messing around with OKV based on RELEASETYPE 208 # messing around with OKV based on RELEASETYPE
177 KV_FULL=${OKV}${EXTRAVERSION} 209 KV_FULL=${OKV}${EXTRAVERSION}
178 210
179 # we will set this for backwards compatibility. 211 # we will set this for backwards compatibility.
180 S=${WORKDIR}/linux-${KV_FULL} 212 S=${WORKDIR}/linux-${KV_FULL}
181 KV=${KV_FULL} 213 KV=${KV_FULL}
182 214
183 # -rc-bk pulls can be achieved by specifying CKV 215 # -rc-git pulls can be achieved by specifying CKV
184 # for example: 216 # for example:
185 # CKV="2.6.11_rc3_pre2" 217 # CKV="2.6.11_rc3_pre2"
186 # will pull: 218 # will pull:
187 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2 219 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
188 220
189 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 221 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
190 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 222 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
191 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 223 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
192 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 224 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
193 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 225 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
194 fi 226 fi
195 227
196 if [[ ${RELEASETYPE} == -bk ]]; then 228 if [[ ${RELEASETYPE} == -git ]]; then
197 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 229 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
198 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 230 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
199 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 231 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
200 fi 232 fi
201 233
202 if [[ ${RELEASETYPE} == -rc-bk ]]; then 234 if [[ ${RELEASETYPE} == -rc-git ]]; then
203 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 235 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
204 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 236 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
205 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 237 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
206 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 238 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
207 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 239 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
208 fi 240 fi
241
242 debug-print-kernel2-variables
209 243
210 handle_genpatches 244 handle_genpatches
211} 245}
212 246
213kernel_is() { 247kernel_is() {
214 [[ -z ${OKV} ]] && detect_version 248 [[ -z ${OKV} ]] && detect_version
215 local operator test value x=0 y=0 z=0 249 local operator test value x=0 y=0 z=0
216 250
217 case ${1} in 251 case ${1} in
218 lt) operator="-lt"; shift;; 252 lt) operator="-lt"; shift;;
219 gt) operator="-gt"; shift;; 253 gt) operator="-gt"; shift;;
225 259
226 for x in ${@}; do 260 for x in ${@}; do
227 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 261 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
228 value="${value}${x}" 262 value="${value}${x}"
229 z=$((${z} + 1)) 263 z=$((${z} + 1))
230 264
231 case ${z} in 265 case ${z} in
232 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done; 266 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
233 test="${test}${KV_MAJOR}";; 267 test="${test}${KV_MAJOR}";;
234 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done; 268 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
235 test="${test}${KV_MINOR}";; 269 test="${test}${KV_MINOR}";;
248 282
249kernel_is_2_6() { 283kernel_is_2_6() {
250 kernel_is 2 6 || kernel_is 2 5 284 kernel_is 2 6 || kernel_is 2 5
251} 285}
252 286
253kernel_header_destdir() {
254 [[ ${CTARGET} == ${CHOST} ]] \
255 && echo /usr/include \
256 || echo /usr/${CTARGET}/include
257}
258
259# Capture the sources type and set DEPENDs 287# Capture the sources type and set DEPENDs
260if [[ ${ETYPE} == sources ]]; then 288if [[ ${ETYPE} == sources ]]; then
261 DEPEND="!build? ( sys-apps/sed 289 DEPEND="!build? ( sys-apps/sed
262 >=sys-devel/binutils-2.11.90.0.31 ) 290 >=sys-devel/binutils-2.11.90.0.31 )"
263 doc? ( app-text/docbook-sgml-utils
264 app-text/xmlto )"
265 RDEPEND="${DEPEND}
266 !build? ( >=sys-libs/ncurses-5.2 291 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
267 sys-devel/make )" 292 sys-devel/make )"
293 PDEPEND="virtual/dev-manager"
268 294
269 PROVIDE="virtual/linux-sources" 295 PROVIDE="virtual/linux-sources"
270 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 296 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
297
271 SLOT="${PVR}" 298 SLOT="${PVR}"
272 DESCRIPTION="Sources for the Linux kernel" 299 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel"
273 IUSE="${IUSE} symlink build doc" 300 IUSE="symlink build"
274elif [[ ${ETYPE} == headers ]]; then 301elif [[ ${ETYPE} == headers ]]; then
275 DESCRIPTION="Linux system headers" 302 DESCRIPTION="Linux system headers"
276 IUSE="${IUSE}" 303
277 304 # Since we should NOT honour KBUILD_OUTPUT in headers
305 # lets unset it here.
306 unset KBUILD_OUTPUT
307
278 if [[ ${CTARGET} = ${CHOST} ]]; then 308 if [[ ${CTARGET} = ${CHOST} ]]; then
279 DEPEND="!virtual/os-headers" 309 DEPEND="!virtual/os-headers"
280 PROVIDE="virtual/kernel virtual/os-headers" 310 PROVIDE="virtual/os-headers"
281 SLOT="0" 311 SLOT="0"
282 else 312 else
283 SLOT="${CTARGET}" 313 SLOT="${CTARGET}"
284 fi 314 fi
285else 315else
286 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 316 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
287 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 317 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
288fi 318fi
289 319
320# Cross-compile support functions
321#==============================================================
322kernel_header_destdir() {
323 [[ ${CTARGET} == ${CHOST} ]] \
324 && echo /usr/include \
325 || echo /usr/${CTARGET}/usr/include
326}
327
328cross_pre_c_headers() {
329 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
330}
331
332env_setup_xmakeopts() {
333 # Kernel ARCH != portage ARCH
334 export KARCH=$(tc-arch-kernel)
335
336 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
337 # variables properly or bad things happen !
338 xmakeopts="ARCH=${KARCH}"
339 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
340 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
341 elif type -p ${CHOST}-ar > /dev/null ; then
342 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
343 fi
344 export xmakeopts
345}
346
290# Unpack functions 347# Unpack functions
291#============================================================== 348#==============================================================
292unpack_2_4() { 349unpack_2_4() {
293 # Kernel ARCH != portage ARCH
294 local ARCH=$(tc-arch-kernel)
295
296 cd ${S}
297 # this file is required for other things to build properly, 350 # this file is required for other things to build properly,
298 # so we autogenerate it 351 # so we autogenerate it
299 make mrproper || die "make mrproper died" 352 make -s mrproper ${xmakeopts} || die "make mrproper failed"
353 make -s symlinks ${xmakeopts} || die "make symlinks failed"
300 make include/linux/version.h || die "make include/linux/version.h failed" 354 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
301 echo ">>> version.h compiled successfully." 355 echo ">>> version.h compiled successfully."
356}
302 357
303 ARCH=$(tc-arch) 358unpack_2_6() {
359 # this file is required for other things to build properly, so we
360 # autogenerate it ... generate a .config to keep version.h build from
361 # spitting out an annoying warning
362 make -s mrproper ${xmakeopts} 2>/dev/null \
363 || die "make mrproper failed"
364
365 # quick fix for bug #132152 which triggers when it cannot include linux
366 # headers (ie, we have not installed it yet)
367 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
368 touch .config
369 eerror "make defconfig failed."
370 eerror "assuming you dont have any headers installed yet and continuing"
371 epause 5
372 fi
373
374 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
375 || die "make include/linux/version.h failed"
376 rm -f .config >/dev/null
304} 377}
305 378
306universal_unpack() { 379universal_unpack() {
307 cd ${WORKDIR} 380 cd ${WORKDIR}
308 unpack linux-${OKV}.tar.bz2 381 unpack linux-${OKV}.tar.bz2
382 if [[ -d "linux" ]]; then
383 mv linux linux-${KV_FULL} \
384 || die "Unable to move source tree to ${KV_FULL}."
309 if [[ "${OKV}" != "${KV_FULL}" ]]; then 385 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
310 mv linux-${OKV} linux-${KV_FULL} \ 386 mv linux-${OKV} linux-${KV_FULL} \
311 || die "Unable to move source tree to ${KV_FULL}." 387 || die "Unable to move source tree to ${KV_FULL}."
312 fi 388 fi
313 cd ${S} 389 cd "${S}"
314 390
315 # remove all backup files 391 # remove all backup files
316 find . -iname "*~" -exec rm {} \; 2> /dev/null 392 find . -iname "*~" -exec rm {} \; 2> /dev/null
317 393
318 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 394 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
319 use ppc && \ 395 # only do this for kernel < 2.6.27 since this file does not exist in later
396 # kernels
397 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
398 then
399 sed -i \
320 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 400 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
321 ${S}/arch/ppc/Makefile 401 "${S}"/arch/ppc/Makefile
402 else
403 sed -i \
404 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
405 "${S}"/arch/powerpc/Makefile
406 fi
322} 407}
323 408
324unpack_set_extraversion() { 409unpack_set_extraversion() {
325 cd ${S} 410 cd "${S}"
326 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 411 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
327 cd ${OLDPWD} 412 cd "${OLDPWD}"
328} 413}
329 414
330# Should be done after patches have been applied 415# Should be done after patches have been applied
331# Otherwise patches that modify the same area of Makefile will fail 416# Otherwise patches that modify the same area of Makefile will fail
332unpack_fix_install_path() { 417unpack_fix_install_path() {
333 cd ${S} 418 cd "${S}"
334 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 419 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
335}
336
337unpack_fix_docbook() {
338 if [[ -d ${S}/Documentation/DocBook ]]; then
339 cd ${S}/Documentation/DocBook
340 sed -ie "s:db2:docbook2:g" Makefile
341 cd ${OLDPWD}
342 fi
343} 420}
344 421
345# Compile Functions 422# Compile Functions
346#============================================================== 423#==============================================================
347compile_headers() { 424compile_headers() {
348 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it 425 env_setup_xmakeopts
349 # if it exists.
350 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
351 426
352 # if we couldnt obtain HOSTCFLAGS from the Makefile, 427 # if we couldnt obtain HOSTCFLAGS from the Makefile,
353 # then set it to something sane 428 # then set it to something sane
354 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS ${S}/Makefile) 429 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
355 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 430 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
356
357 # Kernel ARCH != portage ARCH
358 local KARCH=$(tc-arch-kernel)
359
360 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
361 # variables properly or bad things happen !
362 local xmakeopts="ARCH=${KARCH}"
363 if [[ ${CTARGET} != ${CHOST} ]]; then
364 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
365 elif type -p ${CHOST}-ar; then
366 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
367 fi
368 431
369 if kernel_is 2 4; then 432 if kernel_is 2 4; then
370 yes "" | make oldconfig ${xmakeopts} 433 yes "" | make oldconfig ${xmakeopts}
371 echo ">>> make oldconfig complete" 434 echo ">>> make oldconfig complete"
372 use sparc && make dep ${xmakeopts} 435 make dep ${xmakeopts}
373 elif kernel_is 2 6; then 436 elif kernel_is 2 6; then
437 # 2.6.18 introduces headers_install which means we dont need any
438 # of this crap anymore :D
439 kernel_is ge 2 6 18 && return 0
440
374 # autoconf.h isnt generated unless it already exists. plus, we have 441 # autoconf.h isnt generated unless it already exists. plus, we have
375 # no guarantee that any headers are installed on the system... 442 # no guarantee that any headers are installed on the system...
376 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 443 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
377 || touch include/linux/autoconf.h 444 || touch include/linux/autoconf.h
378 445
379 # if K_DEFCONFIG isn't set, force to "defconfig" 446 # if K_DEFCONFIG isn't set, force to "defconfig"
380 # needed by mips 447 # needed by mips
381 if [[ -z ${K_DEFCONFIG} ]]; then 448 if [[ -z ${K_DEFCONFIG} ]]; then
449 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
450 case ${CTARGET} in
451 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
452 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
453 *) K_DEFCONFIG="defconfig";;
454 esac
455 else
382 K_DEFCONFIG="defconfig" 456 K_DEFCONFIG="defconfig"
457 fi
383 fi 458 fi
384 459
385 # if there arent any installed headers, then there also isnt an asm 460 # if there arent any installed headers, then there also isnt an asm
386 # symlink in /usr/include/, and make defconfig will fail, so we have 461 # symlink in /usr/include/, and make defconfig will fail, so we have
387 # to force an include path with $S. 462 # to force an include path with $S.
388 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 463 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
389 ln -sf asm-${KARCH} "${S}"/include/asm 464 ln -sf asm-${KARCH} "${S}"/include/asm
465 cross_pre_c_headers && return 0
466
390 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 467 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
468 if compile_headers_tweak_config ; then
469 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
470 fi
391 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 471 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
392 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 472 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
393 fi 473 fi
394} 474}
395 475
396compile_manpages() { 476compile_headers_tweak_config() {
397 einfo "Making manpages ..." 477 # some targets can be very very picky, so let's finesse the
398 env -u ARCH make mandocs 478 # .config based upon any info we may have
479 case ${CTARGET} in
480 sh*)
481 sed -i '/CONFIG_CPU_SH/d' .config
482 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
483 return 0;;
484 esac
485
486 # no changes, so lets do nothing
487 return 1
399} 488}
400 489
401# install functions 490# install functions
402#============================================================== 491#==============================================================
403install_universal() { 492install_universal() {
404 #fix silly permissions in tarball 493 #fix silly permissions in tarball
405 cd ${WORKDIR} 494 cd ${WORKDIR}
406 chown -R root:root * 495 chown -R root:0 * >& /dev/null
407 chmod -R a+r-w+X,u+w * 496 chmod -R a+r-w+X,u+w *
408 cd ${OLDPWD} 497 cd ${OLDPWD}
409} 498}
410 499
411install_headers() { 500install_headers() {
412 local ddir=$(kernel_header_destdir) 501 local ddir=$(kernel_header_destdir)
413 502
503 # 2.6.18 introduces headers_install which means we dont need any
504 # of this crap anymore :D
505 if kernel_is ge 2 6 18 ; then
506 env_setup_xmakeopts
507 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
508
509 # let other packages install some of these headers
510 rm -rf "${D}"/${ddir}/sound #alsa-headers
511 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
512 return 0
513 fi
514
515 # Do not use "linux/*" as that can cause problems with very long
516 # $S values where the cmdline to cp is too long
414 cd ${S} 517 cd "${S}"
415 dodir ${ddir}/linux 518 dodir ${ddir}/linux
416 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux 519 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
417 rm -rf ${D}/${ddir}/linux/modules 520 rm -rf "${D}"/${ddir}/linux/modules
418 521
419 # Handle multilib headers 522 # Handle multilib headers and crap
523 local multi_dirs="" multi_defs=""
420 case $(tc-arch-kernel) in 524 case $(tc-arch-kernel) in
421 sparc64) 525 sparc64)
422 dodir ${ddir}/asm-sparc 526 multi_dirs="sparc sparc64"
423 cp -ax ${S}/include/asm-sparc/* ${D}/${ddir}/asm-sparc 527 multi_defs="!__arch64__ __arch64__"
424
425 dodir ${ddir}/asm-sparc64
426 cp -ax ${S}/include/asm-sparc64/* ${D}/${ddir}/asm-sparc64
427
428 create_ml_includes ${ddir}/asm !__arch64__:${ddir}/asm-sparc __arch64__:${ddir}/asm-sparc64
429 ;; 528 ;;
430 x86_64) 529 x86_64)
431 dodir ${ddir}/asm-i386 530 multi_dirs="i386 x86_64"
432 cp -ax ${S}/include/asm-i386/* ${D}/${ddir}/asm-i386 531 multi_defs="__i386__ __x86_64__"
433
434 dodir ${ddir}/asm-x86_64
435 cp -ax ${S}/include/asm-x86_64/* ${D}/${ddir}/asm-x86_64
436
437 create_ml_includes ${ddir}/asm __i386__:${ddir}/asm-i386 __x86_64__:${ddir}/asm-x86_64
438 ;; 532 ;;
439 ppc64) 533 ppc64)
440 dodir ${ddir}/asm-ppc 534 multi_dirs="ppc ppc64"
441 cp -ax ${S}/include/asm-ppc/* ${D}/${ddir}/asm-ppc 535 multi_defs="!__powerpc64__ __powerpc64__"
442 536 ;;
443 dodir ${ddir}/asm-ppc64 537 s390x)
444 cp -ax ${S}/include/asm-ppc64/* ${D}/${ddir}/asm-ppc64 538 multi_dirs="s390 s390x"
445 539 multi_defs="!__s390x__ __s390x__"
446 create_ml_includes ${ddir}/asm !__powerpc64__:${ddir}/asm-ppc __powerpc64__:${ddir}/asm-ppc64
447 ;; 540 ;;
448 arm) 541 arm)
449 dodir ${ddir}/asm 542 dodir ${ddir}/asm
450 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 543 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
451 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -s arch-ebsa285 ${D}/${ddir}/asm/arch 544 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
452 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -s proc-armv ${D}/${ddir}/asm/proc 545 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
546 ;;
547 powerpc)
548 dodir ${ddir}/asm
549 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
550 if [[ -e "${S}"/include/asm-ppc ]] ; then
551 dodir ${ddir}/asm-ppc
552 cp -pPR "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
553 fi
453 ;; 554 ;;
454 *) 555 *)
455 dodir ${ddir}/asm 556 dodir ${ddir}/asm
456 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 557 cp -pPR "${S}"/include/asm/* ${D}/${ddir}/asm
457 ;; 558 ;;
458 esac 559 esac
560 if [[ -n ${multi_dirs} ]] ; then
561 local d ml_inc=""
562 for d in ${multi_dirs} ; do
563 dodir ${ddir}/asm-${d}
564 cp -pPR "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
565
566 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
567 multi_defs=${multi_defs#* }
568 done
569 create_ml_includes ${ddir}/asm ${ml_inc}
570 fi
459 571
460 if kernel_is 2 6; then 572 if kernel_is 2 6; then
461 dodir ${ddir}/asm-generic 573 dodir ${ddir}/asm-generic
462 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic 574 cp -pPR "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic
463 fi 575 fi
464 576
465 # clean up 577 # clean up
466 find "${D}" -name '*.orig' -exec rm -f {} \; 578 find "${D}" -name '*.orig' -exec rm -f {} \;
467 579
468 cd ${OLDPWD} 580 cd ${OLDPWD}
469} 581}
470 582
471install_sources() { 583install_sources() {
472 local doc docs file 584 local file
473 585
474 cd ${S} 586 cd "${S}"
475 dodir /usr/src 587 dodir /usr/src
476 echo ">>> Copying sources ..." 588 echo ">>> Copying sources ..."
477 589
478 file="$(find ${WORKDIR} -iname "docs" -type d)" 590 file="$(find ${WORKDIR} -iname "docs" -type d)"
479 if [[ -n ${file} ]]; then 591 if [[ -n ${file} ]]; then
480 for file in $(find ${file} -type f); do 592 for file in $(find ${file} -type f); do
481 echo "${file//*docs\/}" >> ${S}/patches.txt 593 echo "${file//*docs\/}" >> "${S}"/patches.txt
482 echo "===================================================" >> ${S}/patches.txt 594 echo "===================================================" >> "${S}"/patches.txt
483 cat ${file} >> ${S}/patches.txt 595 cat ${file} >> "${S}"/patches.txt
484 echo "===================================================" >> ${S}/patches.txt 596 echo "===================================================" >> "${S}"/patches.txt
485 echo "" >> ${S}/patches.txt 597 echo "" >> "${S}"/patches.txt
486 done 598 done
487 fi 599 fi
488 600
489 if [[ ! -f ${S}/patches.txt ]]; then 601 if [[ ! -f ${S}/patches.txt ]]; then
490 # patches.txt is empty so lets use our ChangeLog 602 # patches.txt is empty so lets use our ChangeLog
491 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 603 [[ -f ${FILESDIR}/../ChangeLog ]] && \
492 echo "Please check the ebuild ChangeLog for more details." \ 604 echo "Please check the ebuild ChangeLog for more details." \
493 > ${S}/patches.txt 605 > "${S}"/patches.txt
494 fi 606 fi
495
496 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
497 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
498 use doc && ! use arm && ! use s390 && install_manpages
499 dodoc ${docs}
500 607
501 mv ${WORKDIR}/linux* ${D}/usr/src 608 mv ${WORKDIR}/linux* ${D}/usr/src
502}
503
504install_manpages() {
505 kernel_is lt 2 5 && return
506 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" \
507 scripts/makeman Documentation/DocBook/Makefile
508 ebegin "Installing manpages"
509 env -u ARCH make installmandocs
510 eend $?
511 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" \
512 scripts/makeman Documentation/DocBook/Makefile
513} 609}
514 610
515# pkg_preinst functions 611# pkg_preinst functions
516#============================================================== 612#==============================================================
517preinst_headers() { 613preinst_headers() {
522 618
523# pkg_postinst functions 619# pkg_postinst functions
524#============================================================== 620#==============================================================
525postinst_sources() { 621postinst_sources() {
526 local MAKELINK=0 622 local MAKELINK=0
527 623
528 # if we have USE=symlink, then force K_SYMLINK=1 624 # if we have USE=symlink, then force K_SYMLINK=1
529 use symlink && K_SYMLINK=1 625 use symlink && K_SYMLINK=1
530 626
531 # if we are to forcably symlink, delete it if it already exists first. 627 # if we are to forcably symlink, delete it if it already exists first.
532 if [[ -n ${K_SYMLINK} ]]; then 628 if [[ ${K_SYMLINK} > 0 ]]; then
533 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 629 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
534 MAKELINK=1 630 MAKELINK=1
535 fi 631 fi
536 632
537 # if the link doesnt exist, lets create it 633 # if the link doesnt exist, lets create it
538 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 634 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
539 635
540 if [[ ${MAKELINK} == 1 ]]; then 636 if [[ ${MAKELINK} == 1 ]]; then
541 cd ${ROOT}usr/src 637 cd ${ROOT}usr/src
542 ln -sf linux-${KV_FULL} linux 638 ln -sf linux-${KV_FULL} linux
543 cd ${OLDPWD} 639 cd ${OLDPWD}
544 fi 640 fi
545 641
546 # Don't forget to make directory for sysfs 642 # Don't forget to make directory for sysfs
547 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 643 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
548 644
549 echo 645 echo
550 einfo "After installing a new kernel of any version, it is important"
551 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
552 einfo "created (X.Y is the first 2 parts of your new kernel version)"
553 echo
554 einfo "For example, this kernel will require:"
555 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
556 echo
557 einfo "If you are upgrading from a previous kernel, you may be interested" 646 elog "If you are upgrading from a previous kernel, you may be interested"
558 einfo "in the following documents:" 647 elog "in the following document:"
559 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 648 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
560 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
561 echo 649 echo
562 650
563 # if K_EXTRAEINFO is set then lets display it now 651 # if K_EXTRAEINFO is set then lets display it now
564 if [[ -n ${K_EXTRAEINFO} ]]; then 652 if [[ -n ${K_EXTRAEINFO} ]]; then
565 echo ${K_EXTRAEINFO} | fmt | 653 echo ${K_EXTRAEINFO} | fmt |
566 while read -s ELINE; do einfo "${ELINE}"; done 654 while read -s ELINE; do einfo "${ELINE}"; done
567 fi 655 fi
568 656
657 # if K_EXTRAELOG is set then lets display it now
658 if [[ -n ${K_EXTRAELOG} ]]; then
659 echo ${K_EXTRAELOG} | fmt |
660 while read -s ELINE; do elog "${ELINE}"; done
661 fi
662
569 # if K_EXTRAEWARN is set then lets display it now 663 # if K_EXTRAEWARN is set then lets display it now
570 if [[ -n ${K_EXTRAEWARN} ]]; then 664 if [[ -n ${K_EXTRAEWARN} ]]; then
571 echo ${K_EXTRAEWARN} | fmt | 665 echo ${K_EXTRAEWARN} | fmt |
572 while read -s ELINE; do ewarn "${ELINE}"; done 666 while read -s ELINE; do ewarn "${ELINE}"; done
573 fi 667 fi
668
669 # optionally display security unsupported message
670 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
671 echo
672 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
673 ewarn "This means that it is likely to be vulnerable to recent security issues."
674 ewarn "For specific information on why this kernel is unsupported, please read:"
675 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
676 fi
677
678 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
679 KV_MAJOR=$(get_version_component_range 1 ${OKV})
680 KV_MINOR=$(get_version_component_range 2 ${OKV})
681 KV_PATCH=$(get_version_component_range 3 ${OKV})
682 if [[ "$(tc-arch)" = "sparc" ]] \
683 && [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
684 then
685 echo
686 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
687 elog "you now need to do"
688 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
689 elog "instead of just"
690 elog " make"
691 elog "to compile the kernel. For more information please browse to"
692 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
693 echo
694 fi
574} 695}
575 696
576postinst_headers() { 697postinst_headers() {
577 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 698 elog "Kernel headers are usually only used when recompiling your system libc, as"
578 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 699 elog "such, following the installation of newer headers, it is advised that you"
579 einfo "emerge glibc" 700 elog "re-merge your system libc."
580 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 701 elog "Failure to do so will cause your system libc to not make use of newer"
581 einfo "headers." 702 elog "features present in the updated kernel headers."
582} 703}
583 704
584# pkg_setup functions 705# pkg_setup functions
585#============================================================== 706#==============================================================
586setup_headers() { 707setup_headers() {
600 721
601# unipatch 722# unipatch
602#============================================================== 723#==============================================================
603unipatch() { 724unipatch() {
604 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 725 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
605 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG 726 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG extglob_bak
606 727
607 # set to a standard locale to ensure sorts are ordered properly. 728 # set to a standard locale to ensure sorts are ordered properly.
608 myLC_ALL="${LC_ALL}" 729 myLC_ALL="${LC_ALL}"
609 myLANG="${LANG}" 730 myLANG="${LANG}"
610 LC_ALL="C" 731 LC_ALL="C"
611 LANG="" 732 LANG=""
612 733
613 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 734 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
614 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 735 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
615 736
616 # We're gonna need it when doing patches with a predefined patchlevel 737 # We're gonna need it when doing patches with a predefined patchlevel
738 extglob_bak=$(shopt -p extglob)
617 shopt -s extglob 739 shopt -s extglob
618 740
619 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 741 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
620 # usage can be either via an env var or by params 742 # usage can be either via an env var or by params
621 # although due to the nature we pass this within this eclass 743 # although due to the nature we pass this within this eclass
623 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 745 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
624 UNIPATCH_LIST="${@}" 746 UNIPATCH_LIST="${@}"
625 747
626 #unpack any passed tarballs 748 #unpack any passed tarballs
627 for i in ${UNIPATCH_LIST}; do 749 for i in ${UNIPATCH_LIST}; do
628 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 750 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
629 extention=${i/*./}
630 extention=${extention/:*/}
631 case ${extention} in
632 tbz2) PIPE_CMD="tar -xvjf";;
633 bz2) PIPE_CMD="tar -xvjf";;
634 tgz) PIPE_CMD="tar -xvzf";;
635 gz) PIPE_CMD="tar -xvzf";;
636 *) eerror "Unrecognized tarball compression"
637 die "Unrecognized tarball compression";;
638 esac
639
640 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 751 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
641 unset z 752 unset z
642 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 753 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
643 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 754 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
644 do z="${z}0"; 755 do z="${z}0";
645 done 756 done
646 PATCH_ORDER="${z}${STRICT_COUNT}" 757 PATCH_ORDER="${z}${STRICT_COUNT}"
647 758
648 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 759 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
649 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 760 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
761 unpack ${i##*/}
762 popd >/dev/null
650 else 763 else
651 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 764 pushd "${KPATCH_DIR}" >/dev/null
765 unpack ${i##*/}
766 popd >/dev/null
652 fi 767 fi
653 768
654 if [ $? == 0 ]; then
655 einfo "${i/*\//} unpacked"
656 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 769 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
657 else
658 eerror "Failed to unpack ${i/:*/}"
659 die "unable to unpack patch tarball"
660 fi
661 else 770 else
662 extention=${i/*./} 771 extention=${i/*./}
663 extention=${extention/:*/} 772 extention=${extention/:*/}
664 PIPE_CMD="" 773 PIPE_CMD=""
665 case ${extention} in 774 case ${extention} in
708 KPATCH_DIR="" 817 KPATCH_DIR=""
709 for i in $(find ${x} -type d | sort -n); do 818 for i in $(find ${x} -type d | sort -n); do
710 KPATCH_DIR="${KPATCH_DIR} ${i}" 819 KPATCH_DIR="${KPATCH_DIR} ${i}"
711 done 820 done
712 821
822 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
823 # bug #272676
824 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
825 if [[ ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
826 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
827 echo
828 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
829 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
830 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
831 echo
832 fi
833 fi
834
713 #so now lets get rid of the patchno's we want to exclude 835 #so now lets get rid of the patchno's we want to exclude
714 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 836 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
715 for i in ${UNIPATCH_DROP}; do 837 for i in ${UNIPATCH_DROP}; do
716 ebegin "Excluding Patch #${i}" 838 ebegin "Excluding Patch #${i}"
717 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done 839 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
730 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 852 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
731 853
732 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 854 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
733 while [ ${PATCH_DEPTH} -lt 5 ]; do 855 while [ ${PATCH_DEPTH} -lt 5 ]; do
734 echo "Attempting Dry-run:" >> ${STDERR_T} 856 echo "Attempting Dry-run:" >> ${STDERR_T}
735 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 857 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
736 echo "=======================================================" >> ${STDERR_T} 858 echo "=======================================================" >> ${STDERR_T}
737 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 859 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
738 echo "Attempting patch:" > ${STDERR_T} 860 echo "Attempting patch:" > ${STDERR_T}
739 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 861 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
740 echo "=======================================================" >> ${STDERR_T} 862 echo "=======================================================" >> ${STDERR_T}
741 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 863 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
742 eend 0 864 eend 0
743 rm ${STDERR_T} 865 rm ${STDERR_T}
744 break 866 break
745 else 867 else
746 eend 1 868 eend 1
758 die "Unable to dry-run patch." 880 die "Unable to dry-run patch."
759 fi 881 fi
760 done 882 done
761 done 883 done
762 884
885 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
886 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
887 # which is why I'm not taking too much time over this.
888 local tmp
889 for i in ${UNIPATCH_DOCS}; do
890 tmp="${tmp} ${i//*\/}"
891 cp -f ${i} ${T}/
892 done
893 UNIPATCH_DOCS="${tmp}"
894
763 # clean up KPATCH_DIR's - fixes bug #53610 895 # clean up KPATCH_DIR's - fixes bug #53610
764 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 896 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
765 897
766 LC_ALL="${myLC_ALL}" 898 LC_ALL="${myLC_ALL}"
767 LANG="${myLANG}" 899 LANG="${myLANG}"
900 eval ${extglob_bak}
768} 901}
769 902
770# getfilevar accepts 2 vars as follows: 903# getfilevar accepts 2 vars as follows:
771# getfilevar <VARIABLE> <CONFIGFILE> 904# getfilevar <VARIABLE> <CONFIGFILE>
772# pulled from linux-info 905# pulled from linux-info
781 else 914 else
782 workingdir=${PWD} 915 workingdir=${PWD}
783 basefname=$(basename ${2}) 916 basefname=$(basename ${2})
784 basedname=$(dirname ${2}) 917 basedname=$(dirname ${2})
785 unset ARCH 918 unset ARCH
786 919
787 cd ${basedname} 920 cd ${basedname}
788 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 921 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
789 make ${BUILD_FIXES} -s -f - e 2>/dev/null 922 make ${BUILD_FIXES} -s -f - e 2>/dev/null
790 cd ${workingdir} 923 cd ${workingdir}
791 924
792 ARCH=${xarch} 925 ARCH=${xarch}
793 fi 926 fi
794} 927}
795 928
796detect_arch() { 929detect_arch() {
804 # ARCH_URI is the URI for all the ${ARCH}_URI patches 937 # ARCH_URI is the URI for all the ${ARCH}_URI patches
805 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 938 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
806 939
807 ARCH_URI="" 940 ARCH_URI=""
808 ARCH_PATCH="" 941 ARCH_PATCH=""
809 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 942 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
810 943
811 for LOOP_ARCH in ${ALL_ARCH}; do 944 for LOOP_ARCH in ${ALL_ARCH}; do
812 COMPAT_URI="${LOOP_ARCH}_URI" 945 COMPAT_URI="${LOOP_ARCH}_URI"
813 COMPAT_URI="${!COMPAT_URI}" 946 COMPAT_URI="${!COMPAT_URI}"
814 947
884 return 0 1017 return 0
885} 1018}
886 1019
887headers___fix() { 1020headers___fix() {
888 # Voodoo to partially fix broken upstream headers. 1021 # Voodoo to partially fix broken upstream headers.
889 # Issues with this function should go to plasmaroo. 1022 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
890 sed -i \ 1023 sed -i \
891 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1024 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
892 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1025 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
893 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1026 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
894 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1027 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1028 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
895 "$@" 1029 "$@"
896} 1030}
897 1031
898# common functions 1032# common functions
899#============================================================== 1033#==============================================================
900kernel-2_src_unpack() { 1034kernel-2_src_unpack() {
901 universal_unpack 1035 universal_unpack
1036 debug-print "Doing unipatch"
902 1037
903 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1038 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
904 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1039 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
905 1040
1041 debug-print "Doing premake"
1042
1043 # allow ebuilds to massage the source tree after patching but before
1044 # we run misc `make` functions below
1045 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1046
1047 debug-print "Doing unpack_set_extraversion"
1048
906 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1049 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
907 unpack_fix_docbook
908 unpack_fix_install_path 1050 unpack_fix_install_path
909 1051
1052 # Setup xmakeopts and cd into sourcetree.
1053 env_setup_xmakeopts
1054 cd "${S}"
1055
1056 # We dont need a version.h for anything other than headers
1057 # at least, I should hope we dont. If this causes problems
1058 # take out the if/fi block and inform me please.
1059 # unpack_2_6 should now be 2.6.17 safe anyways
1060 if [[ ${ETYPE} == headers ]]; then
910 kernel_is 2 4 && unpack_2_4 1061 kernel_is 2 4 && unpack_2_4
1062 kernel_is 2 6 && unpack_2_6
1063 fi
911} 1064}
912 1065
913kernel-2_src_compile() { 1066kernel-2_src_compile() {
914 cd ${S} 1067 cd "${S}"
915 [[ ${ETYPE} == headers ]] && compile_headers 1068 [[ ${ETYPE} == headers ]] && compile_headers
916 [[ ${ETYPE} == sources ]] && \
917 use doc && ! use arm && ! use s390 && compile_manpages
918} 1069}
919 1070
920kernel-2_pkg_preinst() { 1071kernel-2_pkg_preinst() {
921 [[ ${ETYPE} == headers ]] && preinst_headers 1072 [[ ${ETYPE} == headers ]] && preinst_headers
922} 1073}
931 [[ ${ETYPE} == headers ]] && postinst_headers 1082 [[ ${ETYPE} == headers ]] && postinst_headers
932 [[ ${ETYPE} == sources ]] && postinst_sources 1083 [[ ${ETYPE} == sources ]] && postinst_sources
933} 1084}
934 1085
935kernel-2_pkg_setup() { 1086kernel-2_pkg_setup() {
1087 if kernel_is 2 4; then
1088 if [ "$( gcc-major-version )" -eq "4" ] ; then
1089 echo
1090 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1091 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1092 ewarn "newer kernel that supports gcc-4."
1093 echo
1094 ewarn "Also be aware that bugreports about gcc-4 not working"
1095 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1096 echo
1097 epause 10
1098 fi
1099 fi
1100
1101 ABI="${KERNEL_ABI}"
936 [[ ${ETYPE} == headers ]] && setup_headers 1102 [[ ${ETYPE} == headers ]] && setup_headers
937 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1103 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
938} 1104}
939
940kernel-2_pkg_prerm() {
941 local KV_DIR=${ROOT}/usr/src/linux-${KV_FULL}
942
943 if [[ ${ETYPE} == sources ]]; then
944 # if we have a config for it then we should act on it.
945 if [[ -f ${KV_DIR}/.config ]]; then
946 gzip -c ${KV_DIR}/.config > ${KV_DIR}.config.gz
947 fi
948
949 # have kbuild clean up for us.
950 if [[ -f ${KV_DIR}/include/linux/version.h ]]; then
951 ARCH=$(tc-arch-kernel)
952 make -C ${KV_DIR} mrproper
953 fi
954 fi
955}

Legend:
Removed from v.1.132  
changed lines
  Added in v.1.221

  ViewVC Help
Powered by ViewVC 1.1.20